function varargout = esl_seg_ui(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @esl_seg_ui_OpeningFcn, ...
                   'gui_OutputFcn',  @esl_seg_ui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before esl_seg_ui is made visible.
function esl_seg_ui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = esl_seg_ui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


function height_edit_Callback(hObject, eventdata, handles)

function spacing_edit_Callback(hObject, eventdata, handles)

function wire_edit_Callback(hObject, eventdata, handles)

function segment_edit_Callback(hObject, eventdata, handles)

function resistor_edit_Callback(hObject, eventdata, handles)

function trafo_edit_Callback(hObject, eventdata, handles)

function static_edit_Callback(hObject, eventdata, handles)

function distance_edit_Callback(hObject, eventdata, handles)

function segmentation_menu_Callback(hObject, eventdata, handles)

function angle_edit_Callback(hObject, eventdata, handles)

function simulation_button_Callback(hObject, eventdata, handles)

h=str2num(get(handles.height_edit,'string'));
d=1e-3*str2num(get(handles.spacing_edit,'string'));
dx=1e-3*str2num(get(handles.wire_edit,'string'));
Nx=str2num(get(handles.segment_edit,'string'));
R=1e3*str2num(get(handles.resistor_edit,'string'));
Ntrafo=str2num(get(handles.trafo_edit,'string'));
Vstatic=str2num(get(handles.static_edit,'string'));
r=str2num(get(handles.distance_edit,'string'));
phi=str2num(get(handles.angle_edit,'string'));

segtype=get(handles.segmentation_menu,'value');

w=omega;
switch segtype
case 1
    [p,z]=eslfilt(w,d,h,dx,Nx,R,Ntrafo,Vstatic);
case 2
    [p,z]=eslfiltpar(w,d,h,dx,Nx,R,Ntrafo,Vstatic);
end
q=eslout(w,p,dx,phi,r);

f=w/2/pi;
axes(handles.axes1);
cla
semilogx(f,db(p),'b');
axis([10,1e5,min(db(p(:)))-5,max(db(p(:)))+5]);
ylabel('Geluidsdruk (dB)');
title('Geluidsdruk direct aan voorzijde ESL folie bij 2.83 Volt.');
grid on
zoom on
axes(handles.axes2);
cla
semilogx(f,db(q));
axis([10,1e5,min(db(q(:)))-5,max(db(q(:)))+5]);
xlabel('Frekwentie (Hz)')
ylabel('Geluidsdruk (dB)');
title('Geluidsdruk op luisterpositie bij 2.83 Volt');
grid on
zoom on

ndraden=size(p,2);
breedte=ndraden*dx*100;
st={['totaal aantal draden: ',int2str(ndraden)];'';['totale ESL breedte: ',num2str(breedte),' cm']};
set(handles.report_text,'string',st);




function [P,Z]=eslfilt(w,d,h,dx,Nx,R,Ntrafo,Vstatic)

w(1)=w(2);

perm=8.85419e-12;
p0=20e-6;
dc=perm*h*dx/2/d; % Capacitance of a single wire
Vesl=sqrt(8)*Ntrafo; % Voltage on ESL at 2.83 Volts

C=Nx*dc; % Capacitance per segment pair
C(2:end)=2*C(2:end); % Symmetric on both sides
R(1)=2*R(1);
Z=1./(j*w*C); % Impedance per segment pair

nx=Nx(1)+2*sum(Nx(2:end)); % Total number of wires
Ns=length(Nx); % Number of segment pairs

G=ones(size(Z)); % Gain of ment pair
G(:,Ns)=Z(:,Ns)./(Z(:,Ns)+R(Ns)); % Local gain by mentation resistor
Z(:,Ns)=Z(:,Ns)+R(Ns); % Add resistor to impedance
for n=(Ns-1):-1:1
    Z(:,n)=Z(:,n).*Z(:,n+1)./(Z(:,n)+Z(:,n+1)); % Parallel new segment with earlier part of ladder
    G(:,n)=Z(:,n)./(Z(:,n)+R(n)); % Local gain by mentation resistor
    Z(:,n)=Z(:,n)+R(n); % Add resistor to impedance
end
Z=Z(:,1); % In the end only the input impedance of the ESL is relevant.
G=cumprod(G,2); % Total gain is cumprod of local gains

index=[];
for n=[Ns:-1:1,2:Ns]
    index=[index,repmat(n,1,Nx(:,n))];
end

c=perm*Vstatic*Vesl/d/d/p0; % Electrostatic pressure of ESL at foil, relative to p0.
c=c/2; % Air Pressure right in front of foil 
P=c*G(:,index);


function [P,Z]=eslfiltpar(w,d,h,dx,Nx,R,Ntrafo,Vstatic)

w(1)=w(2);

perm=8.85419e-12;
p0=20e-6;
dc=perm*h*dx/2/d; % Capacitance of a single wire
Vesl=sqrt(8)*Ntrafo; % Voltage on ESL at 2.83 Volts

C=Nx*dc; % Capacitance per segment pair
C(2:end)=2*C(2:end); % Symmetric on both sides
R(1)=2*R(1);
Z=1./(j*w*C); % Impedance per segment pair

nx=Nx(1)+2*sum(Nx(2:end)); % Total number of wires
Ns=length(Nx); % Number of segment pairs

R=repmat(R,size(Z,1),1); %
G=Z./(Z+R); % Global gain by sermentation resistors
Z=Z+R;
Z=sum(Z,2); % In the end only the input impedance of the ESL is relevant.

index=[];
for n=[Ns:-1:1,2:Ns]
    index=[index,repmat(n,1,Nx(:,n))];
end

c=perm*Vstatic*Vesl/d/d/p0; % Electrostatic pressure of ESL at foil, relative to p0.
c=c/2;
P=c*G(:,index);


function q=eslout(w,p,dx,phi,r)

nx=size(p,2);
xx=(1:nx)*dx;
xx=xx-mean(xx);

vs=343;
q=repmat(1,size(p,1),length(phi));
for n=1:length(phi)
   xr=r*sin(phi(n)*pi/180);
   yr=r*cos(phi(n)*pi/180);
   R=sqrt((xr-xx).^2+yr.^2);
   CS=yr./R;
   K=omega./vs;
   K(1)=K(2);
   q(:,n)=sum(-j*pi*p.*(K*CS).*besselh(1,2,K*R),2);
end
q=dx*q/2/pi;


function w=omega

nf=101;
flow=10;
fhigh=1e5;
w=2*pi*10.^linspace(log10(flow),log10(fhigh),nf).';


function A=db(A)

A=abs(A);
A(A<1e-10)=1e-10;
A=20*log10(A);